<?php
/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2015, Ebenezer Obasi
 * All rights reserved.
 * info@eobai.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

class SHAREBTN_CTRL_Admin extends ADMIN_CTRL_Abstract
{
	public function settings()
	{
		$lang = OW::getLanguage();
		
		$this->setPageTitle($lang->text('sharebtn', 'admin_page_title'));
		$this->setPageHeading($lang->text('sharebtn', 'admin_page_heading'));
		$this->setPageHeadingIconClass('ow_ic_mail');
		
		$form = new Form('sharebtn_settings');
		
		$defaultPlace = new Selectbox('default_place');
		$defaultPlace->setLabel($lang->text('sharebtn', 'default_place_label'));
		$defaultPlace->setDescription($lang->text('sharebtn', 'default_place_desc'));
		$defaultPlace->setOptions(array(
			4 => $lang->text('sharebtn', 'default_place_dashboard'), 
			8 => $lang->text('sharebtn', 'default_place_profile'), 
			1 => $lang->text('sharebtn', 'default_place_index')
		));
		$defaultPlace->setRequired();
		$form->addElement($defaultPlace);
		
		$useLogo = new Selectbox('use_logo');
		$useLogo->setLabel($lang->text('sharebtn', 'use_logo_label'));
		$useLogo->setDescription($lang->text('sharebtn', 'use_logo_desc'));
		$useLogo->setOptions(array(
			0 => $lang->text('sharebtn', 'admin_option_no'), 
			1 => $lang->text('sharebtn', 'admin_option_yes')
		));
		$useLogo->setRequired();
		$form->addElement($useLogo);
		
		$buttonIcon = new Selectbox('button_ic');
		$buttonIcon->setLabel($lang->text('sharebtn', 'button_icon_label'));
		$buttonIcon->setDescription($lang->text('sharebtn', 'button_icon_desc'));
		$buttonIcon->setOptions(array(
			'&#43;' => 'Plus sign',
			'&#10162;' => 'Circled heavy white rightwards arrow',
			'&#10021;' => 'Four club-spoked asterisk',
			'&#10026;' => 'Circled white star',
			'&#9825;' => 'Empty Heart',
			'&#10084;' => 'Big Heart',
			'&#10086;' => 'Floral Heart',
			'&#128147;' => 'Heart Pulse',
			'&#9822;' => 'Black chess knight',
			'&#9775;' => 'Yin Yang',
			'&#2384;' => 'Devanagari Om',
			'&#127929' => 'Keyboard',
			'&#9998;' => 'Pencil',
			'&#9760;' => 'Skull and crossbones',
			'&#128274;' => 'Padlock',
			'&#9732;' => 'Comet',
			'&#9832;' => 'Hot springs',
			'&#9729;' => 'Cloud',
			'&#9997;' => 'Writing hand',
			'&#9996;' => 'Victory hand',
			'&#9731;' => 'Snowman',
			'&#9730;' => 'Umbrella'
		));
		$buttonIcon->setRequired();
		$form->addElement($buttonIcon);
		
		$logoUrl = new TextField('logo_url');
        $logoUrl->setLabel($lang->text("sharebtn", "logo_url_label"));
        $logoUrl->setHasInvitation(true);
        $logoUrl->setInvitation($lang->text('sharebtn', 'logo_url_example'));
        $logoUrl->setDescription($lang->text('sharebtn', 'logo_url_desc'));
		$form->addElement($logoUrl);
		
		$buttonTxt = new TextField('button_txt');
        $buttonTxt->setLabel($lang->text("sharebtn", "button_txt_label"));
        $buttonTxt->setHasInvitation(true);
        $buttonTxt->setInvitation($lang->text('sharebtn', 'button_txt_example'));
        $buttonTxt->setDescription($lang->text('sharebtn', 'button_txt_desc'));
		$buttonTxt->setRequired();
		$form->addElement($buttonTxt);
		
		$buttonColor = new TextField('button_color');
        $buttonColor->setLabel($lang->text("sharebtn", "button_color_label"));
        $buttonColor->setHasInvitation(true);
        $buttonColor->setInvitation($lang->text('sharebtn', 'button_color_example'));
        $buttonColor->setDescription($lang->text('sharebtn', 'button_color_desc'));
		$buttonColor->setRequired();
		$form->addElement($buttonColor);
		
		$buttonBg = new TextField('button_bg');
        $buttonBg->setLabel($lang->text("sharebtn", "button_bg_label"));
        $buttonBg->setHasInvitation(true);
        $buttonBg->setInvitation($lang->text('sharebtn', 'button_bg_example'));
        $buttonBg->setDescription($lang->text('sharebtn', 'button_bg_desc'));
		$buttonBg->setRequired();
		$form->addElement($buttonBg);
		
		$buttonSave = new Submit('save');
		$buttonSave->setValue($lang->text('sharebtn', 'admin_button_save_value'));
		$form->addElement($buttonSave);
		
		$this->addForm($form);
		
		$config = OW::getConfig();
		
		if ( OW::getRequest()->isPost() && $form->isValid($_POST) )
		{
			$data = $form->getValues();
			
			$config->saveConfig('sharebtn', 'default_place', trim($data['default_place']));
			$config->saveConfig('sharebtn', 'use_logo', trim($data['use_logo']));
			$config->saveConfig('sharebtn', 'button_ic', trim($data['button_ic']));
			$config->saveConfig('sharebtn', 'logo_url', trim($data['logo_url']));
			$config->saveConfig('sharebtn', 'button_txt', trim($data['button_txt']));
			$config->saveConfig('sharebtn', 'button_color', trim($data['button_color']));
			$config->saveConfig('sharebtn', 'button_bg', trim($data['button_bg']));
			
			OW::getFeedback()->info($lang->text('sharebtn', 'admin_successfully_saved'));
			
			$this->redirect();
		}
		
		$defaultPlace->setValue($config->getValue('sharebtn', 'default_place'));
		$useLogo->setValue($config->getValue('sharebtn', 'use_logo'));
		$buttonIcon->setValue($config->getValue('sharebtn', 'button_ic'));
		$logoUrl->setValue($config->getValue('sharebtn', 'logo_url'));
		$buttonTxt->setValue($config->getValue('sharebtn', 'button_txt'));
		$buttonColor->setValue($config->getValue('sharebtn', 'button_color'));
		$buttonBg->setValue($config->getValue('sharebtn', 'button_bg'));
		
		$this->addForm($form);
	}
}