<?php

class SHAREBTN_CTRL_Share extends OW_ActionController
{

    public function js()
    {
		header('Content-type: text/javascript');
		$gr = OW::getRouter();
		$config = OW::getConfig();
		$gpm = OW::getPluginManager();
		
		$shareUrl = $gr->urlForRoute('sharebtn_share_newsfeed');
		$siteName = $config->getValue('base', 'site_name');
		$hashSiteName = 'ewtnet_'.md5($siteName);
		//$jsUrl = $gpm->getPlugin('sharebtn')->getStaticJsUrl() . 'sharer.js';
		//$imageUrl = $gpm->getPlugin('sharebtn')->getStaticUrl() . 'img/';
		
		$logoUrl = $config->getValue('sharebtn', 'logo_url');
		$bg = $config->getValue('sharebtn', 'button_bg');
		$color = $config->getValue('sharebtn', 'button_color');
		if(!empty($logoUrl) && $config->getValue('sharebtn', 'use_logo') == 1){
			$icon = '<img src="'.$logoUrl.'" style="width:18px;height:18px;vertical-align:text-top;" ></img>';
		}else{
			$icon = $config->getValue('sharebtn', 'button_ic');
		}
		$text = $config->getValue('sharebtn', 'button_txt');
		
		$jsContent="
			document.getElementById('$hashSiteName').onclick = function() {shareWindow()};
			function shareWindow(){
				var linkData = document.getElementById('$hashSiteName');
				var uri = window.location.href;
				if(linkData.dataset.href.length){
					var uri = linkData.dataset.href;
				}
				var title = document.title;
				if(linkData.dataset.title.length){
					var content = linkData.dataset.title;
				}
				var url = '$shareUrl?uri='+uri+'&title='+title+'&content='+content;
				window.open(url, '$hashSiteName', 'scrollbars=yes,width=800,height=520');
				return true
			}
			//Styles
			var sharebtn = document.getElementById('$hashSiteName');
			//sharebtn.style.backgroundImage = 'url($logoUrl)';
			sharebtn.style.padding = '5px';
			sharebtn.style.backgroundColor = '$bg';
			sharebtn.style.color = '$color';
			sharebtn.style.fontSize = '13px';
			sharebtn.style.lineHeight = '18px';
			sharebtn.style.textDecoration = 'none';
			sharebtn.style.cursor = 'pointer';
			sharebtn.innerHTML = '$icon $text';
			var size = sharebtn.dataset.size;
			if(size == 'medium'){
				sharebtn.style.fontSize = '18px';
				sharebtn.style.lineHeight = '24px';
			}
			else if(size == 'large'){
				sharebtn.style.fontSize = '24px';
				sharebtn.style.lineHeight = '30px';
			}
		";
		echo($jsContent);
		die;
		
	}
    public function index()
    {
		$gd = OW::getDocument();
		$lang = OW::getLanguage();
		$gr = OW::getRouter();
		$config = OW::getConfig();
		$gpm = OW::getPluginManager();

		$gd->addStyleSheet(OW::getPluginManager()->getPlugin('sharebtn')->getStaticCssUrl() . 'style.css');
        $gd->setTitle($lang->text('sharebtn', 'sharebtn_developers_page_title'));
        $gd->setHeading($lang->text("sharebtn", "sharebtn_developers_page_heading"));
		
		$shareUrl = $gr->urlForRoute('sharebtn_share_index');
		$this->assign('shareUrl', $shareUrl);
		$jsUrl = $gr->urlForRoute('sharebtn_share_js');
		$this->assign('jsUrl', $jsUrl);
		$siteName = $config->getValue('base', 'site_name');
		$this->assign('hashSiteName', 'ewtnet_'.md5($siteName));
		$this->assign('siteName',$siteName);
		
		$form = new Form('sharebtn_dynamic_event_form');
		
		$fieldSharebtnContent = new Textarea('sharebtnContent');
        $fieldSharebtnContent->setLabel($lang->text("sharebtn", "share_button_config_content_label"));
		$fieldSharebtnContent->addAttribute('onchange', 'sharebtn_update()');
		$fieldSharebtnContent->addAttribute('value', "$siteName");
		$fieldSharebtnContent->addAttribute('id', "sharebtnContent");
		$form->addElement($fieldSharebtnContent);
		
		$fieldSharebtnUrl = new TextField('sharebtnUrl');
        $fieldSharebtnUrl->setLabel($lang->text("sharebtn", "share_button_config_url_label"));
		$fieldSharebtnUrl->addAttribute('onchange', 'sharebtn_update()');
		$fieldSharebtnUrl->addAttribute('value', "$shareUrl");
		$fieldSharebtnUrl->addAttribute('id', "sharebtnUrl");
		$form->addElement($fieldSharebtnUrl);
		
		$fieldSharebtnSize = new Selectbox('sharebtnSize');
		$fieldSharebtnSize->setLabel($lang->text('sharebtn', 'share_button_config_size_label'));
		$fieldSharebtnSize->addAttribute('onchange', 'sharebtn_update()');
		$fieldSharebtnSize->addAttribute('id', "sharebtnSize");
		$fieldSharebtnSize->setOptions(array(
			'small' => 'Small',
			'medium' => 'Medium',
			'large' => 'Large'
		));
		$fieldSharebtnSize->setValue('small');
		$form->addElement($fieldSharebtnSize);
		
		$this->addForm($form);
	}
    public function newsfeed()
    {
		if ( !OW::getUser()->isAuthenticated() )
        {
            throw new AuthenticateException();
        }
        $lang = OW::getLanguage();
		$gd = OW::getDocument();
		$gr = OW::getRouter();
		$config = OW::getConfig();
		$gpm = OW::getPluginManager();
		$siteName = $config->getValue('base', 'site_name');
		$this->assign('siteName', $siteName);
		
		$gd->getMasterPage()->setTemplate(OW::getThemeManager()->getMasterPageTemplate(OW_MasterPage::TEMPLATE_BLANK));
		$gd->addStyleSheet(OW::getPluginManager()->getPlugin('sharebtn')->getStaticCssUrl() . 'sharer.css');
        $gd->setTitle($siteName);
		$header = $lang->text('sharebtn', 'sharer_page_header', array('siteName' => $siteName));
		$this->assign('header',$header);
		
		$pageUri = $_REQUEST['uri'];
		$pageTitle = $_REQUEST['title'];
		if(!empty($pageTitle)){
			$feedContent = $_REQUEST['content'];
		}else{
			$feedContent = $_REQUEST['title'];
		}
        $newsfeedForm = new Form('NewsfeedForm');
        $newsfeedForm->setEnctype(Form::ENCTYPE_MULTYPART_FORMDATA);

        $place = new Selectbox('place');
        $place->setLabel($lang->text('sharebtn', 'place_on'));
        $options = array(
            '4'=>$lang->text('sharebtn', 'dashboard_newsfeed_label'),
            '1'=>$lang->text('sharebtn', 'index_newsfeed_label'),
            '8'=>$lang->text('sharebtn', 'profile_newsfeed_label')
        );
		$place->setValue($config->getValue('sharebtn', 'default_place'));
        $place->setOptions($options);
        $place->setRequired();
        $newsfeedForm->addElement($place);
		
        $content = new Textarea('content');
        $content->setLabel($lang->text('sharebtn', 'item_content'));
		$content->addAttribute('placeholder', $lang->text('sharebtn', 'sharer_content_label'));
		$content->addAttribute('value', "$feedContent $pageUri");
        $content->setRequired();
        $newsfeedForm->addElement($content);

        $submitButton = new Submit('submit');
        $submitButton->setValue($lang->text('sharebtn', 'submit_entity'));

        $newsfeedForm->addElement($submitButton);

        $this->addForm($newsfeedForm);

        //$this->assign('username', OW::getUser()->getUserObject()->getUsername());

        $avatarList = BOL_AvatarService::getInstance()->getDataForUserAvatars(array(OW::getUser()->getId()));
        $this->assign('avatar', $avatarList[OW::getUser()->getId()]);

        //Processing form data after submit
        if ( OW::getRequest()->isPost() && $newsfeedForm->isValid($_POST) )
        {
            $data = $newsfeedForm->getValues();
			$status = strip_tags($data['content']);
			$status = UTIL_HtmlTag::autoLink($status);
			$userId = OW::getUser()->getId();
			$visibility = $data['place'];
			$entityId = strrev(substr((int)($userId/2).rand(pow(7,time()), pow(8,7) - 1),0,7));
			
            $eventData = array(
                'time' => time(),
                'string' => '',
				'content' => array(
					'format' => 'content',
					'vars' => array(
						'title' => $pageTitle,
						'description' => $status,
						'url' => $pageUri,
						'iconClass' => 'ow_ic_add'
					)
				),
                'view' => array(
                    'iconClass' => 'ow_ic_add'
                )
            );
						
            $event = new OW_Event('feed.action', array(
                'pluginKey' => 'sharebtn',
                'entityType' => 'sharebtn_entity',
                'entityId' => $entityId,
                'userId' => $userId,
                'visibility' => $visibility,
            ), $eventData);
            OW::getEventManager()->trigger($event);
			
            OW::getFeedback()->info($lang->text('sharebtn', 'shared_success_msg').$options[$data['place']]);
			$closeWindow = "
				closeWindow()
			";
			OW::getDocument()->addOnloadScript($closeWindow);
        }
		
    }
}