<?php

class SHAREBTN_MCTRL_Share extends SHAREBTN_CTRL_Share
{

    public function newsfeed()
    {
		if ( !OW::getUser()->isAuthenticated() )
        {
            throw new AuthenticateException();
        }
        $lang = OW::getLanguage();
		$gd = OW::getDocument();
		$gr = OW::getRouter();
		$config = OW::getConfig();
		$gpm = OW::getPluginManager();
		$siteName = $config->getValue('base', 'site_name');
		$this->assign('siteName', $siteName);
		
		$gd->getMasterPage()->setTemplate(OW::getThemeManager()->getMasterPageTemplate(OW_MobileMasterPage::TEMPLATE_BLANK));
		OW::getThemeManager()->addDecorator('ipc', 'sharebtn');
		$gd->addStyleSheet($gpm->getPlugin('sharebtn')->getStaticCssUrl() . 'mobile_sharer.css');
        $gd->setTitle($siteName);
		$header = $lang->text('sharebtn', 'sharer_page_header', array('siteName' => $siteName));
		$this->assign('header',$header);
		
		$pageUri = $_REQUEST['uri'];
		$pageTitle = $_REQUEST['title'];
		if(!empty($pageTitle)){
			$feedContent = $_REQUEST['content'];
		}else{
			$feedContent = $_REQUEST['title'];
		}
        $newsfeedForm = new Form('NewsfeedForm');
        $newsfeedForm->setEnctype(Form::ENCTYPE_MULTYPART_FORMDATA);

        $place = new Selectbox('place');
        $place->setLabel($lang->text('sharebtn', 'place_on'));
        $options = array(
            '4'=>$lang->text('sharebtn', 'dashboard_newsfeed_label'),
            '1'=>$lang->text('sharebtn', 'index_newsfeed_label'),
            '8'=>$lang->text('sharebtn', 'profile_newsfeed_label')
        );
		$place->setValue($config->getValue('sharebtn', 'default_place'));
        $place->setOptions($options);
        $place->setRequired();
        $newsfeedForm->addElement($place);
		
        $content = new Textarea('content');
        $content->setLabel($lang->text('sharebtn', 'item_content'));
		$content->addAttribute('placeholder', $lang->text('sharebtn', 'sharer_content_label'));
		$content->addAttribute('value', "$feedContent $pageUri");
        $content->setRequired();
        $newsfeedForm->addElement($content);

        $submitButton = new Submit('submit');
        $submitButton->setValue($lang->text('sharebtn', 'submit_entity'));

        $newsfeedForm->addElement($submitButton);

        $this->addForm($newsfeedForm);

        //$this->assign('username', OW::getUser()->getUserObject()->getUsername());

        $avatarList = BOL_AvatarService::getInstance()->getDataForUserAvatars(array(OW::getUser()->getId()));
        $this->assign('avatar', $avatarList[OW::getUser()->getId()]);

        //Processing form data after submit
        if ( OW::getRequest()->isPost() && $newsfeedForm->isValid($_POST) )
        {
            $data = $newsfeedForm->getValues();
			$status = strip_tags($data['content']);
			$status = UTIL_HtmlTag::autoLink($status);
			$userId = OW::getUser()->getId();
			$visibility = $data['place'];
			$entityId = strrev(substr((int)($userId/2).rand(pow(7,time()), pow(8,7) - 1),0,7));
			
            $eventData = array(
                'time' => time(),
                'string' => '',
				'content' => array(
					'format' => 'content',
					'vars' => array(
						'title' => $pageTitle,
						'description' => $status,
						'url' => $pageUri,
						'iconClass' => 'ow_ic_add'
					)
				),
                'view' => array(
                    'iconClass' => 'ow_ic_add'
                )
            );
						
            $event = new OW_Event('feed.action', array(
                'pluginKey' => 'sharebtn',
                'entityType' => 'sharebtn_entity',
                'entityId' => $entityId,
                'userId' => $userId,
                'visibility' => $visibility,
            ), $eventData);
            OW::getEventManager()->trigger($event);
			
            OW::getFeedback()->info($lang->text('sharebtn', 'shared_success_msg').$options[$data['place']]);
			$closeWindow = "
				closeWindow()
			";
			OW::getDocument()->addOnloadScript($closeWindow);
        }
		
    }
}